/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

/* Temporaries have a '$' in front, the temp used are:

1) Loop indexes: need only 7 ($i1, ..., $i7). Declare only the necessary by
   keeping a count.
*/

#include "extern.h"

static U_DEFINE_STACK (arrays, Node*, 100)

temp_end ()  /* clears internal stuff */
{
	U_stack_clear_arrays ();
}

temp_decl()  /* called just before declarations */
{
	ostart ();
	array_decl ();
/* ##BEGIN##, 02/23/1992, ZEKI */
        llb_decl();
        lub_decl();
        common_decl(); /* declearse some common minLoc1 and maxLoc1 */
	desc_decl (); /* decleras ARRAY_INFO par. for attr_npac_intrinsic*/
        proclist_decl(); /* decleras PROCLIST par. for attr_npac_intrinsic*/
        comm_decl (); /* declares ARRAY_COMM for communication element */
	opt_decl ();
	para_decl ();
/* ##BEGIN##, 02/23/1992, ZEKI */
/*	auto_decl ();   */
	temp_arrays_decl ();
	cubix_decl ();
/* ZEKI */
 /* not declare intrinsic function because I make it subroutine CALL*/
	decl_intrin_decl (); 
	oend ();
}

temp_init ()  /* called after declarations, during writing */
{
/* ##BEGIN##, 02/23/1992, ZEKI */
        proclist_init(); /* proclist(1)=-1 */
	desc_init (); /* BOZKUS */
	para_init ();
/* ##BEGIN##, 02/23/1992, ZEKI */
/*	auto_init ();*/
}
/* BOZKUS */
proclist_init()
{
 otab();
 ostr("proclist(1)=-1");
 odon();
}

/* to make temporary we "just" need to declare it */

Node *temp_make (typ, alloc, upd)  /* make temporary according to typ */
Typ *typ;
int alloc;  /* = 0 only for automatic array functions */
Node **upd;
{
	Node *sublist, *name, *opt7, *decl, *temp;
	char *tname;
	T_Entry *entry;

	tname = U_malloc (2 + 5 + 5 + 1);
	sprintf (tname, "$T%dtemp", arrays_top);/*ZEKI*/

	sublist = typ_shape_to_sublist_decl (typ->shape);
	se_EtypeSpec = typ->etype;

	name = make_Name (tname);
	opt7 = make_opt7 (sublist);
	decl = make_EntityDecl (name, opt7);
	decl = parse_EntityDecl (decl);

	U_stack_push_arrays (decl);

	name = make_Name (tname);
	temp = make_Variable (name);
	temp = parse_Variable (temp);

	name = make_Name (tname);
	*upd = make_Variable (name);
	*upd = parse_Variable (*upd);

	entry = lookup_loc (tname);
	SET_temporary (entry);

	if (expr_sublist_not_constant (sublist)) {
		Node *code, *stmt;
		int i;

		SET_alloc_temp (entry);

		if (alloc) {  /* note that the extents are not known if alloc = 0 */
			stmt = auto_fmalloc_entry (entry);
			(*upd)->com.trans = trans_add_stmt_bef ((*upd)->com.trans, stmt);

			stmt = make (STATEMENT);
			stmt->Statement.fun = desc_init_entry;
			stmt->Statement.arg = (char*) entry;

			(*upd)->com.trans = trans_add_sta_bef ((*upd)->com.trans, stmt);
		}
		else {
			Shape *shape = temp->com.typ->shape;
			Shape *upd_shape = (*upd)->com.typ->shape;

			for (i = 0; i < shape->rank; i++) {
				shape->sizes1[i] = shape->extent[i] = desc_extent (tname, i);
				upd_shape->sizes1[i] = upd_shape->extent[i] = desc_extent (tname, i);
			}
		}

/* ##BEGIN##,02/23/11992, ZEKI */
/* no to call auto free call */
/*		stmt = auto_ffree_entry (entry);

		temp->com.trans = trans_add_stmt_aft (temp->com.trans, stmt);
*/
	}
/* this is set temporary array Org_SubscriptList according to Original style */

        /* BOZKUS */
        temp->ArraySection.Org_SubscriptList = 
             typ_shape_to_sublist (typ->shape); 
        (*upd)->ArraySection.Org_SubscriptList = 
             typ_shape_to_sublist (typ->shape); 

	return temp;
}

Node *temp_make_len (etype, len, alloc) /* make temporary according to typ->etype, len) */
Etype *etype;
Node *len;
int alloc;  /* = 0 only for automatic array functions */
{
	Node *sublist, *name, *opt7, *decl, *temp;
	char *tname;
	T_Entry *entry;
	double value;

	tname = U_malloc (2 + 5 + 5 + 1);
	sprintf (tname, "$T%dtemp", arrays_top); /* ZEKI */

	sublist = typ_len_to_sublist_decl (len);
	se_EtypeSpec = etype;

	name = make_Name (tname);
	opt7 = make_opt7 (sublist);
	decl = make_EntityDecl (name, opt7);
	decl = parse_EntityDecl (decl);

	U_stack_push_arrays (decl);

	name = make_Name (tname);
	temp = make_Variable (name);
	temp = parse_Variable (temp);

	entry = lookup_loc (tname);
	SET_temporary (entry);

	if (!expr_is_constant (len, &value)) {
		Node *code, *stmt;
		int i;

		SET_alloc_temp (entry);

		if (alloc) {  /* note that the extents are not known if alloc = 0*/
			stmt = auto_fmalloc_entry (entry);
			temp->com.trans = trans_add_stmt_bef (temp->com.trans, stmt);

			stmt = make (STATEMENT);
			stmt->Statement.fun = desc_init_entry;
			stmt->Statement.arg = (char*) entry;

			temp->com.trans = trans_add_sta_bef (temp->com.trans, stmt);
		}
		else {
			Shape *shape = temp->com.typ->shape;

			for (i = 0; i < shape->rank; i++) {
				temp->com.typ->shape->sizes1[i] = &Times;
				temp->com.typ->shape->extent[i] = &Times;
			}
		}
/* ##BEGIN##,02/23/11992, ZEKI */
/* no to call auto free call */
/*		stmt = auto_ffree_entry (entry);

		temp->com.trans = trans_add_stmt_aft (temp->com.trans, stmt);
*/
	}

	return temp;
}

temp_arrays_decl ()  /* declares temporaries */
{
	int i;
	Node *decl;
	T_Entry *entry;
        Node *name,*sublist,*opt7;  /* ZEKI */
        int aligned; /* zeki */
	for (i = 0; i < arrays_top; i++) {
		decl = arrays[i];
/* I also put DIRECTIVE_STMT in the stack */                
                if(decl->com.type != DIRECTIVE_STMT)
		  {		
                    otab ();
		    entry = lookup_loc (decl->com.str);
                    aligned = 0;
                    if(entry->align_template != TN) aligned=1;
		    ostr (etype_name (entry->typ->etype));

                /* ##BEGIN##, 02/23/1992, ZEKI */
                /* change  the output of intrinsic array size */
                if(IS_output_of_intrinsic(entry)){
                    sublist = typ_shape_to_sublist_decl (entry->typ->shape);
                   se_EtypeSpec = entry->typ->etype;
/*                   entry = TN; */
                   name = make_Name (decl->com.str);
                   opt7 = make_opt7 (sublist);
                   decl = make_EntityDecl (name, opt7);
                    decl = parse_EntityDecl (decl); 
                }
		  }
                else  /* { odon(); ostart(); ostr("C     ");}*/
		  {   /*och('\007');*/
                      och('C');
                      ostr("     ");
		    }

               /* ##END## */

		write_pass (decl);
		odon ();
             /*   if(aligned) align_decl(entry);*/   /* BOZKUS */
	}
}

/* ##BEG##, 10/30/1991, ZEKI */
/* If you change align syntax you have to change this routine too. */
/* The function of this procedure is to write if temp array is distributed 
  alligned that temp array*/

Node *align_decl(entry)
T_Entry *entry;
{
  /* alignroot => CZ ALIGN alignlist WITH alignspec */
  Node *alignroot, *alignlist, *alignspec, *alignlistspec;
  alignroot = make (DIRECTIVE_STMT);
  alignroot->DirectiveStmt.Diralign = &Diralign;
  alignroot->DirectiveStmt.AlignList =  alignlist = make(ALIGN_LIST);
  alignroot->DirectiveStmt.Dirwith = &Dirwith;
  alignroot->DirectiveStmt.AlignSpec = alignspec = make(ALIGN_SPEC);
  alignspec->AlignSpec.Name =make_Name(entry->align_template->name);
  alignlist->AlignList.AlignSpec = alignlistspec = make(ALIGN_SPEC);
  alignlistspec->AlignSpec.Name =make_Name(entry->orig_name);
  alignspec->AlignSpec.SubscriptList =make(SUBSCRIPT_LIST);
  alignspec->AlignSpec.SubscriptList =entry->template_indexlist;
  alignspec->AlignSpec.Lp = &Lp;
  alignspec->AlignSpec.Rp = &Rp;
  alignlistspec->AlignSpec.SubscriptList =make(SUBSCRIPT_LIST);
  alignlistspec->AlignSpec.SubscriptList =entry->indexlist;
  alignlistspec->AlignSpec.Lp = &Lp;
  alignlistspec->AlignSpec.Rp = &Rp;
  return alignroot;
}

/* this is changed form of temp_replace if whereconstruct call this routine
  this routine will create a temp variable and align that temproray variable
  according to the array in the expression */
Node *temp_replace (expr)
Node *expr;
{
	Node *temp, *stmt, *new_expr, *decl;
        T_Entry *entry1, *entry2, *entry3;
        char *name;  /* will be array name in the expression */
        name = (char *) U_malloc(36); /* I assume array name will less than 36 */

	new_expr = temp_make (expr->com.typ, 1, &temp);
/* following code is to find a array in expr and then align temp according
   to that array if rank are equals */
/* if you want to make smart compiler, it  can align temp even if ranks are not same */
        if(!find_array_in_expr(expr,name))
           if(name){
             entry1 = lookup_loc(arrays[arrays_top-1]->com.str);/*temp array name */
             entry2 = lookup_loc(name);
             if(entry1->typ->shape->rank == entry2->typ->shape->rank)
	       {
             if(entry2->align_template != TN){
/*                      entry3 = lookup_loc(entry2->align_template->name);
                         entry1->align_template = entry3;
*/
                      entry1->align_template = entry2->align_template;
                      entry1->indexlist = entry2->indexlist;
                      entry1->template_indexlist = entry2->template_indexlist;
                      decl = align_decl(entry1);
                      decl = check_align ( decl);
                      U_stack_push_arrays (decl);
		    }
	   }
	      
/*        else
              printf(" I didn't find a array name in the expression\n"); */
	   }
	stmt = make_AssignementStmt (temp, expr);
	stmt = parse_AssignementStmt (stmt);

	new_expr->com.trans = trans_add_stmt_bef (new_expr->com.trans, stmt);

	return new_expr;
}
/* ##END## */
/* ZEKI
Node *temp_replace (expr)
Node *expr;
{
	Node *temp, *stmt, *new_expr;

	new_expr = temp_make (expr->com.typ, 1, &temp);
	stmt = make_AssignementStmt (temp, expr);
	stmt = parse_AssignementStmt (stmt);

	new_expr->com.trans = trans_add_stmt_bef (new_expr->com.trans, stmt);

	return new_expr;
}
*/

Node *temp_replace_in (expr)
Node *expr;
{
	return temp_replace (expr);
}

Node *temp_replace_out (expr)
Node *expr;
{
	Node *temp, *stmt, *new_expr;

	temp = temp_make (expr->com.typ, 1, &new_expr);

	expr = tree_dup (expr);
	stmt = make_AssignementStmt (expr, temp);
	stmt = parse_AssignementStmt (stmt);

/* ...before_last because this way the call eefree from temp_make gets after the
   assign stmt. */

	new_expr->com.trans = trans_add_stmt_aft_before_last (new_expr->com.trans, stmt);

	return new_expr;
}

Node *temp_replace_inout (expr) /* INOUT */
Node *expr;
{
	Node *temp, *stmt, *new_expr;

	new_expr = temp_make (expr->com.typ, 1, &temp);

	stmt = make_AssignementStmt (temp, expr);
	stmt = parse_AssignementStmt (stmt);

	new_expr->com.trans = trans_add_stmt_bef (new_expr->com.trans, stmt);

	temp = make_Variable (make_Name (new_expr->com.str));
	temp = parse_Variable (temp);
	expr = tree_dup (expr);
	stmt = make_AssignementStmt (expr, temp);
	stmt = parse_AssignementStmt (stmt);

/* ...before_last because this way the call eefree from temp_make gets after the
   assign stmt. *//* this can be done more elegantly now */

	new_expr->com.trans = trans_add_stmt_aft_before_last (new_expr->com.trans, stmt);

	return new_expr;
}

